/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api;

import org.objectweb.jalisto.se.api.query.FieldDescription;
import org.objectweb.jalisto.se.api.query.FielComparator;

import java.io.Serializable;
import java.util.Iterator;


public interface ClassDescription extends Serializable {
    String getClassName();

    int getIndex(String fieldName);

    FieldDescription getFieldDescription(int index);

    FielComparator getComparator(int index);

    Iterator getIndexedFieldDescription();

    short getIndexType(int index);

    void setIndexType(int index, short indexType);

    short getNodePageSize(int index);

    void setNodePageSize(int index, short size);

    public short getNodeSize(int index);

    public void setNodeSize(int index, short size);

    public short getLeafPageSize(int index);

    public void setLeafPageSize(int index, short size);

    /**
     * Return an array of the names of the declared fields of the described class.
     * 
     * @return String[] The names of the described class fields.
     */
    public String[] getFieldNames();

    /**
     * Return the number of field already declared for the described class.
     * 
     * @return int The number of declared fields.
     */
    public int getNbrFields();

    /**
     * Insert a new field in the description of the class.
     * 
     * @param fieldDescription The name of the field to insert.
     */
    public void addField(FieldDescription fieldDescription);

    /**
     * Remove a field from the description of the class.
     * 
     * @param index The index of the place where to remove the field.
     */
    public void removeField(int index);

    public String toStringFull(int nbrTab);
}
