/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api;

import org.objectweb.jalisto.se.api.query.FieldDescription;

import java.util.Collection;

public interface MetaRepository {

    void defineClass(Session session, ClassDescription classMetaDescription);

    ClassDescription getMetaData(String className);

    void removeClass(Session session, String className);

    void addField(Session session, String className, FieldDescription fieldDescription);

    String[] getFieldNames(String className);

    void renameField(Session session, String className, String oldFieldName, String newFieldName);

    void removeField(Session session, String className, String fieldName);

    Collection getAllClassNames();

    ClassDescription getPersistentClassMetaDescription(Object clid);

    int getIndex(String className, String fieldName);
}
