/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.internal;

import org.objectweb.jalisto.se.impl.LogicalOid;
import org.objectweb.jalisto.se.api.internal.multi.LockManager;
import org.objectweb.jalisto.se.api.internal.OidTable;
import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.api.JalistoProperties;

import java.util.Collection;

public interface SessionInternal extends Session {

    LogicalSystemPageAccess getFileAccess();

    OidTable getOidTable();

    LockManager getLockManager();

    JalistoProperties getProperties();

    Object getSessionId();

    void clearObjectCache();


    Object makeNewFileOid(LogicalOid floid);

    Object[] readObjectByOid(Object oid, boolean withCache);

    Collection getAllClassNames();

    Collection getFloidsFromClid(Object sessionId, Object clid);

    Long reserveFloids(short clid, int number);


    void setOptimistic();

    void setPessimistic();

    void begin();

    void commit();

    void rollback();

    void checkValidity(String message, boolean mustBeActive);

    boolean isRemoteSession();
}
