/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.internal.multi;

import org.objectweb.jalisto.se.api.internal.DataWrapper;
import org.objectweb.jalisto.se.impl.lock.Lock;

import java.util.Collection;
import java.util.Iterator;

public interface LockTable {
    Iterator getKeys();

    Lock getLockOrCreate(Object floid);

    Lock getLock(Object floid);

    DataWrapper getLockedValue(Object floid, Object sessionId);

    void checkLocksForSession(Collection floids, Object sessionId);

    boolean containsDeletedValue(Object floid, Object sessionId);

    boolean containsLockedValue(Object floid, Object sessionId);

    boolean hasLock(Object floid);

    void publishLocks();

    void removeLockByFloid(Object floid);

    boolean isEmpty();
}
