/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.query;

import org.objectweb.jalisto.se.api.ClassDescription;
import org.objectweb.jalisto.se.impl.LogicalOid;

public interface IndexManager {
    Index getIndex(ClassDescription meta, int fieldIndex);

    Index buildIndexOnField(ClassDescription meta, int fieldIndex);

    void deleteIndexOnField(ClassDescription meta, int fieldIndex);

    void deleteIndexesOnClass(ClassDescription meta);

    void createObject(ClassDescription meta, LogicalOid floid, Object[] value);

    void updateObject(ClassDescription meta, LogicalOid floid, Object[] oldValue, Object[] newValue);

    void removeObject(ClassDescription meta, LogicalOid floid, Object[] value);
}
