/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.exception.remote;

import org.objectweb.jalisto.se.exception.JalistoException;

import java.io.StringWriter;
import java.io.PrintWriter;
import java.io.PrintStream;

public class RemoteException extends JalistoException {

    public RemoteException() {
    }

    public RemoteException(String s) {
        super(s);
        remoteMessage = s;
    }

    public RemoteException(String s, Throwable throwable) {
        super(s);
        remoteMessage = s;
        manageThrowable(throwable);
    }

    public RemoteException(Throwable throwable) {
        super();
        manageThrowable(throwable);
        remoteMessage = throwable.getMessage();
    }

    private void manageThrowable(Throwable throwable) {
        StringWriter sw = new StringWriter();
        throwable.printStackTrace(new PrintWriter(sw));
        sw.flush();
        stackTrace = sw.toString();
    }

    public void printStackTrace() {
        super.printStackTrace();
        if (stackTrace != null) {
            System.err.println("remotly caused by : "+stackTrace);
        }
    }

    public void printStackTrace(PrintStream printStream) {
        super.printStackTrace(printStream);
        if (stackTrace != null) {
            printStream.println("remotly caused by : "+stackTrace);
        }
    }

    public void printStackTrace(PrintWriter printWriter) {
        super.printStackTrace(printWriter);
        if (stackTrace != null) {
            printWriter.println("remotly caused by : "+stackTrace);
        }
    }

    public String getMessage() {
        if (remoteMessage == null) {
            return super.getMessage();
        } else {
            return remoteMessage;
        }
    }

    private String stackTrace;
    private String remoteMessage;
}
