/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl;

import org.objectweb.jalisto.se.api.internal.SessionInternal;
import org.objectweb.jalisto.se.api.Extent;

import java.util.*;

public class ExtentImpl implements Extent {


    public ExtentImpl(Object clid, SessionInternal session) {
        this.session = session;
        this.clid = clid;
        this.floids = new TreeSet();
        this.currentOidPageAddress = "";
    }

    public void cleanFloids() {
        floids.clear();
    }

    public boolean isEmpty() {
        return floids.isEmpty();
    }

    public int size() {
        return floids.size();
    }

    public boolean contains(Object object) {
        return floids.contains(object);
    }

    public Iterator iterator() {
        return floids.iterator();
    }

    public Collection collection() {
        ArrayList list = new ArrayList(floids);
        return list;
    }

    public Extent readFully() {
        session.checkValidity("readFully", true);
        addFloids(session.getFloidsFromClid(session.getSessionId(), clid));
        return this;
    }

    public Extent readNextFloids(int number) {
        session.checkValidity("readNextFloids", true);
        if (session.isRemoteSession()) {
            throw new UnsupportedOperationException();
        }
        addFloids(session.getOidTable().getFloidsFromClid(session.getSessionId(), clid, this, number));
        return this;
    }

    public LogicalOid getLastFloid() {
        return lastFloid;
    }

    public String getStartingAddress() {
        return currentOidPageAddress;
    }

    public void setStartingAddress(String startingAddress) {
        this.currentOidPageAddress = startingAddress;
    }

    public void addFloids(Collection newFloids) {
        floids.addAll(newFloids);
        if (!floids.isEmpty()) {
            lastFloid = (LogicalOid) floids.last();
        }
    }

    public String toString() {
        return floids.toString();
    }

    protected Object clid;
    protected SessionInternal session;
    protected TreeSet floids;
    protected String currentOidPageAddress;
    protected LogicalOid lastFloid;
}
