/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.lock;

import org.objectweb.jalisto.se.api.internal.DataWrapper;

public class ObjectTransactionnalState {

    public ObjectTransactionnalState(int currentAction, DataWrapper currentValue, short update) {
        this.currentAction = currentAction;
        this.currentValue = currentValue;
        this.update = update;
    }


    public int getCurrentAction() {
        return currentAction;
    }

    public boolean isReadAction() {
        return (currentAction == READ_ACTION);
    }

    public boolean isCreateAction() {
        return (currentAction == CREATE_ACTION);
    }


    public DataWrapper getCurrentValue() {
        return currentValue;
    }

    public void setValue(int action, DataWrapper currentValue) {
        if ((action != READ_ACTION) || (currentAction == READ_ACTION)) {
            this.currentValue = currentValue;
            currentAction = action;
        }
    }


    public void update() {
        update++;
    }

    public short getUpdate() {
        return update;
    }

    public void setUpdate(short update) {
        if (update != (short) -1) {
            this.update = update;
        }
    }


    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("ITImage : ").append(getActionAsString(currentAction)).append(", ");
        sb.append(currentValue).append(", update=").append(update);
        return sb.toString();
    }

    private String getActionAsString(int action) {
        if (action == NO_ACTION) {
            return "no_action";
        } else if (action == NEW_OID_ACTION) {
            return "new_action";
        } else if (action == CREATE_ACTION) {
            return "create_action";
        } else if (action == UPDATE_ACTION) {
            return "update_action";
        } else if (action == DELETE_ACTION) {
            return "delete_action";
        } else {
            return "read_action";
        }
    }


    private DataWrapper currentValue;
    private int currentAction;
    private short update;


    public static final int NO_ACTION = 0;
    public static final int NEW_OID_ACTION = 1;
    public static final int CREATE_ACTION = 2;
    public static final int UPDATE_ACTION = 3;
    public static final int DELETE_ACTION = 4;
    public static final int READ_ACTION = 5;
}
