/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.meta;

import org.objectweb.jalisto.se.api.ClassDescription;
import org.objectweb.jalisto.se.api.query.FieldDescription;
import org.objectweb.jalisto.se.api.MetaType;

public class FieldDescriptionImpl implements FieldDescription {

    public FieldDescriptionImpl(String fieldName, MetaType type) {
        this.fieldName = fieldName;
        this.type = type;
        this.index = -1;
        this.indexDescription = new IndexDescription(this);
    }

    public short getIndex() {
        return index;
    }

    public void setIndex(short index) {
        this.index = index;
    }

    public String getFieldName() {
        return fieldName;
    }

    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }

    public MetaType getType() {
        return type;
    }

    public void setType(MetaType type) {
        this.type = type;
    }

    public boolean isIndexDefined() {
        return indexDescription.isIndexDefined();
    }

    public IndexDescription getIndexDescription() {
        return indexDescription;
    }

    public ClassDescription getClassMeta() {
        return classMeta;
    }

    public void setClassMeta(ClassDescription classMeta) {
        this.classMeta = (ClassDescriptionImpl) classMeta;
    }

    public boolean equals(Object o) {
        try {
            FieldDescriptionImpl candidate = (FieldDescriptionImpl) o;
            return (candidate.fieldName.equals(this.fieldName) &&
                    (candidate.index == this.index) &&
//                    (candidate.indexDescription.equals(this.indexDescription)) &&
                    (candidate.type.equals(this.type)));
        } catch (Exception e) {
        }
        return false;
    }

    public String toString() {
        return fieldName + " : " + type.toString();
    }

    private ClassDescriptionImpl classMeta;
    private String fieldName;
    private short index;
    private MetaType type;
    private IndexDescription indexDescription;


    static final long serialVersionUID = -7589377097964763559L;
}
