/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.server.page.info;

import org.objectweb.jalisto.se.impl.InFileAddress;

import java.io.Serializable;
import java.util.Iterator;
import java.util.LinkedList;

public class PageInfo implements Serializable {
    public PageInfo(short pageSize, short pageType) {
        this.freePlaces = new LinkedList();
        this.size = pageSize;
        this.pageType = pageType;

        for (int i = 0; i < size; i++) {
            freePlaces.addLast(new Integer(i));
        }
    }

    public short getPageType() {
        return pageType;
    }

    public Iterator getAllFreePlace() {
        return freePlaces.iterator();
    }

    public boolean isEmpty() {
        return (freePlaces.size() == size);
    }

    public int getEmptySpace() {
        return freePlaces.size();
    }

    public Integer getAFreePlace() {
        Integer result = (Integer) freePlaces.getFirst();
        freePlaces.removeFirst();
        return result;
    }

    public void allocateFreeSpaceAt(Integer index) {
        freePlaces.addLast(index);
    }

    public boolean hasFreeSpaceAt(Integer index) {
        return freePlaces.contains(index);
    }

    public void noMorefreeSpaceAt(Integer index) {
        freePlaces.remove(index);
    }

    public void setPageIfa(InFileAddress pageIfa) {
        this.pageIfa = pageIfa;
    }

    public InFileAddress getPageIfa() {
        return pageIfa.getClone();
    }

    public void setPid(Object pid) {
        this.pid = pid;
    }

    public Object getPid() {
        return pid;
    }

    public PageInfo getClone() {
        PageInfo clone = new PageInfo(size, pageType);
        clone.pageIfa = pageIfa.getClone();
        clone.freePlaces = new LinkedList(freePlaces);
        clone.pid = pid;
        return clone;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("PageInfo:").append(pid).append(':').append(pageIfa)
                .append(':').append(getEmptySpace());

        return sb.toString();
    }


    private InFileAddress pageIfa;
    private LinkedList freePlaces;
    private Object pid;
    private short size;
    private short pageType;


    static final long serialVersionUID = -7589377097964761459L;
}
