/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.server.socket;

import org.objectweb.jalisto.se.api.remote.JalistoServer;
import org.objectweb.jalisto.se.exception.JalistoException;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class JalistoServerSocketImpl implements JalistoServer {

    public void launchServer(int port) {
        System.out.println("Run JalistoServerSocketImpl on port " + port);
        ServerSocket ss;
        try {
            ss = new ServerSocket(port);
        } catch (IOException ioe) {
            throw new JalistoException(ioe);
        }
        try {
            while (true) {
                Socket socket = null;
                try {
                    socket = ss.accept();
                } catch (IOException ioe) {
                    throw new JalistoException(ioe);
                }
                ServerCommunicationAgentSocketImpl serverAgent =
                        new ServerCommunicationAgentSocketImpl(socket);
                serverAgent.start();
            }
        } finally {
            try {
                if ((ss != null) && (!ss.isClosed())) {
                    ss.close();
                }
            } catch (IOException ioe) {
                ioe.printStackTrace();
            }
        }
    }
}