/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.trace;

import java.io.PrintWriter;

public class TracePrintWriter extends TraceImpl {
    private PrintWriter logger;

    protected String getTraceType() {
        return "TracePrintWritter";
    }

    public TracePrintWriter(TraceContext context, Trace current, PrintWriter printWriter) {
        super(context);
        setEnabledModules(current.enabledModules());
        logger = printWriter;
    }

    public TracePrintWriter(TraceContext context, PrintWriter printWriter) {
        super(context);
        logger = printWriter;
    }

    public void printException(Object message, Throwable t) {
        print(TRACE_ON, String.valueOf(message));
        t.printStackTrace(logger);
    }

    protected void print(Module module, String message) {
        logger.print(pad(module));

        if (isShowThread()) {
            logger.print(" {" + Thread.currentThread() + "}");
        }

        logger.println(" " + message);
        logger.flush();
    }

    static final long serialVersionUID = -7589377097964761000L;
}
