/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.storage.raf;

import java.io.ByteArrayInputStream;
import java.util.ArrayList;

public class DbByteArrayInputStream extends ByteArrayInputStream {
    private DbByteArrayInputStream(byte[] data) {
        super(data);
    }

    public byte[] getDataToRead() {
        return super.buf;
    }

    public synchronized void reset() {
        super.reset();
        instances.add(this);
    }

    /** ***********************************     STATIC    **************************************************** */

    private static ArrayList instances = new ArrayList();

    public static DbByteArrayInputStream getInstance(byte[] data) {
        if (instances.isEmpty()) {
            return new DbByteArrayInputStream(data);
        }
        try {
            DbByteArrayInputStream in = (DbByteArrayInputStream) instances.remove(0);
            in.buf = data;
            in.count = data.length;
            return in;
        } catch (ArrayIndexOutOfBoundsException e) {
            return new DbByteArrayInputStream(data);
        }
    }
}
