/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.storage.raf;

import java.io.*;

public class RecordReader {

    public RecordReader(String key, byte[] data) {
        this.key = key;
        this.data = data;
        in = DbByteArrayInputStream.getInstance(data);
    }

    public byte[] getData() {
        return data;
    }

    public InputStream getInputStream() {
        return in;
    }

    public String getKey() {
        return key;
    }

    public ObjectInputStream getObjectInputStream() throws IOException {
        if (objIn == null) {
            objIn = new ObjectInputStream(in);
        }

        return objIn;
    }

    /**
     * Reads the next object in the record using an ObjectInputStream.
     */
    public Object readObject()
            throws IOException, ClassNotFoundException {
        return getObjectInputStream().readObject();
    }

    public void reset() {
        in.reset();
    }

    ByteArrayInputStream in;
    ObjectInputStream objIn;
    String key;
    byte[] data;
}
