/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.storage.raf.log.asynraf;

import org.objectweb.jalisto.se.impl.InFileAddress;

public class LogInfo implements Comparable {

    public byte[] getOldValue() {
        return oldValue;
    }

    public void setOldValue(byte[] oldValue) {
        this.oldValue = oldValue;
    }

    public long getOldValueAddress() {
        return oldValueAddress;
    }

    public void setOldValueAddress(long oldValueAddress) {
        this.oldValueAddress = oldValueAddress;
    }

    public long getOldValueLength() {
        if (oldValue != null) {
            return oldValue.length;
        }
        return oldValueLength;
    }

    public void setOldValueLength(long oldValueLength) {
        this.oldValueLength = oldValueLength;
    }

    public byte[] getValue() {
        return value;
    }

    public void setValue(byte[] value) {
        this.value = value;
    }

    public long getValueAddress() {
        return valueAddress;
    }

    public void setValueAddress(long valueAddress) {
        this.valueAddress = valueAddress;
    }

    public long getValueLength() {
        if (value != null) {
            return value.length;
        }
        return valueLength;
    }

    public void setValueLength(long valueLength) {
        this.valueLength = valueLength;
    }

    public LogInfo(short actionType, InFileAddress ifa, int index) {
        this.actionType = actionType;
        this.ifa = ifa;
        this.index = index;
    }

    public short getActionType() {
        return actionType;
    }

    public InFileAddress getIfa() {
        return ifa;
    }

    public int getIndex() {
        return index;
    }

    public void setIndex(int index) {
        this.index = index;
    }

    public int compareTo(Object object) {
        try {
            LogInfo candidate = (LogInfo) object;
            if (this.index < candidate.index) {
                return -1;
            } else if (this.index == candidate.index) {
                return 0;
            } else {
                return 1;
            }
        } catch (ClassCastException cce) {
        }
        return -1;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        if (actionType == INSERT_TYPE) {
            sb.append("insert:");
        } else if (actionType == UPDATE_TYPE) {
            sb.append("update:");
        } else {
            sb.append("delete:");
        }
        sb.append(ifa);
        return sb.toString();
    }

    private short actionType;
    private InFileAddress ifa;
    private long valueAddress;
    private long valueLength;
    private byte[] value;
    private long oldValueAddress;
    private long oldValueLength;
    private byte[] oldValue;

    private int index;

    public final static short INSERT_TYPE = 44;
    public final static short UPDATE_TYPE = 64;
    public final static short DELETE_TYPE = 97;

}
