/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.storage.raf.nolog.asynchro;

import org.objectweb.jalisto.se.api.internal.JalistoObject;
import org.objectweb.jalisto.se.exception.JalistoException;
import org.objectweb.jalisto.se.impl.InFileAddress;
import org.objectweb.jalisto.se.impl.server.JalistoObjectImpl;

public class UpdateWrapper extends DefaultActionWrapper {
    public void doAction(PhysicalFileAccessNologAsynchroImpl access) {
        access.internalUpdateFileObject(getJalistoObject().getIfa(), getJalistoObject());
    }

    public ActionWrapper upgradeToDelete(InFileAddress ifa) {
        ActionWrapper deleteWrapper = new DeleteWrapper();
        JalistoObject fo = new JalistoObjectImpl();
        fo.setIfa(ifa);
        deleteWrapper.setJalistoObject(fo);
        return deleteWrapper;
    }

    public ActionWrapper upgradeToInsert(JalistoObject insertedValue) {
        throw new JalistoException();
    }

    public ActionWrapper upgradeToUpdate(JalistoObject updatedValue) {
        setJalistoObject(updatedValue);
        return this;
    }

    public String toString() {
        return "update wrapper on " + getJalistoObject().getIfa();
    }
}
