/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.test.data;

import org.objectweb.jalisto.se.api.ClassDescription;
import org.objectweb.jalisto.se.JalistoFactory;
import org.objectweb.jalisto.se.impl.meta.type.MetaTypeFactory;

public class Client {

    private Client() {
    }

    private Client(String firstName, String lastName) {
        this.firstName = firstName;
        this.lastName = lastName;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public boolean equals(Object o) {
        try {
            Client candidate = (Client) o;
            return (candidate.firstName.equals(firstName) &&
                    candidate.lastName.equals(lastName));
        } catch (Exception e) {
        }
        return false;
    }

    public Object[] toArray() {
        Object[] result = new Object[2];
        result[0] = firstName;
        result[1] = lastName;
        return result;
    }

    public static Client toClient(Object[] array) {
        Client client = new Client();
        client.setFirstName((String) array[0]);
        client.setLastName((String) array[1]);
        return client;
    }

    public static ClassDescription getMetaDescription() {
        ClassDescription meta = JalistoFactory.createClassDescription(Client.class.getName());
        meta.addField(JalistoFactory.createFieldDescription("firstName", MetaTypeFactory.StringType));
        meta.addField(JalistoFactory.createFieldDescription("lastName", MetaTypeFactory.StringType));
        return meta;
    }

    public static Client newClient() {
        counter++;
        return new Client(getNewFirstName(counter), getNewLastName(counter));
    }

    private static String getNewFirstName(int c) {
        return firstNames[c % firstNames.length];
    }

    private static String getNewLastName(int c) {
        return lastNames[c % lastNames.length];
    }

    private String firstName;
    private String lastName;

    public static int counter = -1;

    public static final String[] firstNames = {"Katharina",
                                               "Sigourney",
                                               "Winona",
                                               "Jody",
                                               "Famke"};

    public static final String[] lastNames = {"Hepburn",
                                              "Weaver",
                                              "Rider",
                                              "Foster",
                                              "Janssen",
                                              "Seymour",
                                              "Scott Thommas",
                                              "Harlow",
                                              "Kruegger",
                                              "Sastre",
                                              "Pfeiffer",
                                              "Jovovitch",
                                              "Valetta"};
}
