/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.test.data;

import java.io.Serializable;

public class Format implements Serializable {

    public Format() {
    }

    public boolean equals(Object o) {
        try {
            Format candidate = (Format) o;
            return ((candidate.width == this.width) && (candidate.length == this.length));
        } catch (ClassCastException cce) {
        }
        return false;
    }

    public String toString() {
        return String.valueOf(width) + "x" + String.valueOf(length);
    }

    public static Format getNewFormat(int i) {
        Format result = new Format();
        result.width = ((i * 1684657) % 20) + 1;
        result.length = ((i * 48987657) % 15) + 1;
        return result;
    }

    public static Format getFormat() {
        counter++;
        return availableFormat[counter % availableFormat.length];
    }

    int width;
    int length;

    public static int counter = -1;

    public static Format[] availableFormat = {getNewFormat(1),
                                              getNewFormat(2),
                                              getNewFormat(3),
                                              getNewFormat(4),
                                              getNewFormat(5),
                                              getNewFormat(6),
                                              getNewFormat(7)};


    static final long serialVersionUID = -7589377091484761459L;
}
