/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.test.workbench;

import junit.extensions.jfunc.JFuncSuite;
import junit.extensions.jfunc.TestletWrapper;
import junit.framework.Test;
import junit.framework.TestResult;

import java.util.*;

public class JalistoTestSuite extends JFuncSuite {
    private JalistoTestEngine testEngine;

    public JalistoTestSuite() {
        oneTest(true);
    }

    protected void setTestEngine(JalistoTestEngine testEngine) {
        this.testEngine = testEngine;
    }

    protected void setUpOnce(TestResult result) {
        boolean testCaseInit = true;
        for (Iterator i = getTests().iterator(); i.hasNext();) {
            Test test = (Test) i.next();
            if (test instanceof JalistoTestCase) {
                try {
                    JalistoTestCase ldTest = (JalistoTestCase) test;
                    ldTest.setTestEngine(testEngine);
                    if (testCaseInit) {
                        ldTest.setUpOnce();
                        testCaseInit = false;
                    }
                } catch (Exception e) {
                    result.addError(test, e);
                }
            } else if (test instanceof JalistoTestSuite) {
                JalistoTestSuite ldSuite = (JalistoTestSuite) test;
                try {
                    ldSuite.setTestEngine(testEngine);
                } catch (Exception e) {
                    result.addError(test, e);
                }
            }
        }
    }

    private Set getTests() {
        Set tests = new HashSet();
        for (Enumeration e = tests(); e.hasMoreElements();) {
            Test test = (Test) e.nextElement();
            if (test instanceof TestletWrapper) {
                test = ((TestletWrapper) test).getTestInstance();
            }
            tests.add(test);
        }
        return tests;
    }
}
