/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.test.core.single;

import org.objectweb.jalisto.se.JalistoFactory;
import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.api.Transaction;
import org.objectweb.jalisto.se.test.data.Book;
import org.objectweb.jalisto.se.test.threads.BookClientBasic;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class MultiUsersTestReadDatas {
    public static void main(String[] args) {
        String jalistoPropertiesFilename = args[0];
        boolean sameDatas = args[1].equalsIgnoreCase("same");
        int nbrClient = Integer.parseInt(args[2]);
        int nbrBook = Integer.parseInt(args[3]);
        int nbrAction = Integer.parseInt(args[4]);
        int nbrIteration = Integer.parseInt(args[5]);

        ArrayList threads = new ArrayList();
        List oids = null;
        if (sameDatas) {
            oids = populate(jalistoPropertiesFilename, nbrBook);
            oids = Collections.synchronizedList(oids);
        }

        for (int i = 0; i < nbrClient; i++) {
            BookClientBasic c = new BookClientBasic(jalistoPropertiesFilename, i, nbrBook, nbrAction, nbrIteration);
            threads.add(c);
            c.define(true);
            if (sameDatas) {
//                c.setWithExtent(true);
                c.setNbrCreate(5);
                c.setNbrUpdate(5);
                c.setNbrDelete(5);
//                c.setNbrDelete(0);
                c.setOids(oids);
            } else {
                c.setNbrCreate(nbrAction);
                c.setNbrUpdate(nbrAction);
                c.setNbrDelete(nbrAction);
                c.define(true);
                c.populate();
            }
        }

        try {
            for (int i = 0; i < nbrClient; i++) {
                ((BookClientBasic) threads.get(i)).start();
                Thread.sleep(500);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static List populate(String jalistoPropertiesFilename, int nbrBook) {
        Session session = JalistoFactory.getSession(jalistoPropertiesFilename);
        session.openSession();
        Transaction tx = session.currentTransaction();
        session.defineClass(Book.getMetaDescription());
        List oids = new ArrayList();
        tx.begin();
        for (int i = 0; i < nbrBook; i++) {
            oids.add(session.createObject(Book.newBook().toArray(), Book.class));
        }
        tx.commit();
        session.closeSession();
        return oids;
    }
}
