/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.test.core.single;

import org.objectweb.jalisto.se.JalistoFactory;
import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.exception.JalistoException;
import org.objectweb.jalisto.se.test.data.Book;
import org.objectweb.jalisto.se.test.threads.BookClientBasic;

import java.util.ArrayList;

public class ReadOnlyMultiUsersTest {
    public static void main(String[] args) {
        String jalistoPropertiesFilename = args[0];
        String jalistoPropertiesFilenamePre = args[1];
        int nbrInstance = Integer.parseInt(args[2]);
        int nbrClient = Integer.parseInt(args[3]);
        int nbrRead = Integer.parseInt(args[4]);
        int nbrIteration = Integer.parseInt(args[5]);

        ArrayList threads = new ArrayList();
        ArrayList oids = new ArrayList();

        System.out.println("ReadOnlyMultiUsersTest : use " + jalistoPropertiesFilename);

        System.out.println("get extent...");
        Session session = getSession(jalistoPropertiesFilename, jalistoPropertiesFilenamePre, nbrInstance);
        session.currentTransaction().begin();
        oids.addAll(session.getExtent(Book.class).readFully().collection());
        session.currentTransaction().commit();

        System.out.println("reduce oids collection size to " + nbrInstance + " books...");
        if (oids.size() > nbrInstance) {
            ArrayList tmp = new ArrayList();
            while (tmp.size() < nbrInstance) {
                tmp.add(oids.remove(0));
            }
            oids = tmp;
            System.gc();
            System.runFinalization();
            System.gc();
        }

        System.out.println("test : " + nbrRead + " for each of the " + nbrIteration + " iteration");

        System.out.println("create " + nbrClient + " clients...");
        for (int i = 0; i < nbrClient; i++) {
            BookClientBasic c = new BookClientBasic(
                    jalistoPropertiesFilename, i, -1, nbrRead, nbrIteration);
            c.setNbrCreate(-1);
            c.setNbrDelete(-1);
            c.setNbrUpdate(-1);
            threads.add(c);
            c.define(false);
            c.setOids(oids);
        }

        System.out.println("start clients...");
        try {
            for (int i = 0; i < nbrClient; i++) {
                ((BookClientBasic) threads.get(i)).start();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    private static Session getSession(String propFileName, String propFileNamePre, int nbrInstance) {
        try {
            return JalistoFactory.getSession(propFileName);
        } catch (JalistoException jalistoExc) {
            System.out.println("need to create datas...");
            Session prepareSession = JalistoFactory.getSession(propFileNamePre);
            prepareSession.defineClass(Book.getMetaDescription());
            prepareSession.currentTransaction().begin();
            for (int i = 0; i < nbrInstance; i++) {
                prepareSession.createObject(Book.newBook().toArray(), Book.class);
            }
            prepareSession.currentTransaction().commit();
            System.out.println("datas created !");
            return JalistoFactory.getSession(propFileName);
        }
    }
}
