/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.jca.session;

import org.objectweb.jalisto.se.impl.TransactionImpl;
import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.impl.trace.Trace;

import javax.resource.spi.LocalTransaction;
import javax.transaction.Synchronization;

public class ManagedTransactionImpl extends TransactionImpl
        implements Synchronization, LocalTransaction {

    public ManagedTransactionImpl(Session session, Trace trace) {
        super(session);
        this.trace = trace;
    }

    public void afterCompletion(int i) {
        out("afterCompletion... nothing done");
    }

    public void beforeCompletion() {
        out("beforeCompletion nothing done");
    }

    public void enlistAsSynchronization() {
        out("enlistAsSynchronization... nothing done");
    }

    public void begin() {
        out("begin()");
        super.begin();
    }

    public void commit() {
        out("commit()");
        super.commit();
    }

    public void rollback() {
        out("rollback()");
        super.rollback();
    }

    private void out(String msg) {
        trace.println(Trace.JCA, TRACE_ID + " " + msg);
    }

    private static final String TRACE_ID = "[JalistoManagedTransactionImpl]";
    private Trace trace;
}
