/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query;

import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.api.internal.SessionInternal;
import org.objectweb.jalisto.se.api.query.IndexManager;
import org.objectweb.jalisto.se.api.query.QueryManager;
import org.objectweb.jalisto.se.api.query.Query;

public class QueryManagerImpl implements QueryManager {

    public QueryManagerImpl() {
    }

    public void init(SessionInternal session) {
        this.session = session;
    }

    public Query query() {
        return new QueryImpl(this, null);
    }

    public Session getSession() {
        return session;
    }

    public void setQueryResolveMode(int i) {
    }

    public String toString() {
        return "query manager associated with jalistoSession " + session.getSessionId();
    }

    public IndexManager getIndexManager() {
        if (indexManager == null) {
            indexManager = IndexManagerImpl.getAnIndexManagerImpl(session);
        }
        return indexManager;
    }

    private SessionInternal session;
    private IndexManager indexManager;
}
