/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query.index;

import org.objectweb.jalisto.se.api.ClassDescription;
import org.objectweb.jalisto.se.impl.LogicalOid;
import org.objectweb.jalisto.se.impl.InFileAddress;
import org.objectweb.jalisto.se.api.query.Index;
import org.objectweb.jalisto.se.api.query.IndexManager;
import org.objectweb.jalisto.se.api.query.FielComparator;
import org.objectweb.jalisto.se.query.exception.QueryEngineException;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

public class IndexHashMapImpl implements Index {

    public IndexHashMapImpl(InFileAddress ifa, int fieldIndex, ClassDescription meta) {
        System.out.println("build hashmap index");
        this.ifa = ifa;
        this.comparator = meta.getComparator(fieldIndex);
        this.map = new HashMap();
        this.className = meta.getClassName();
        this.fieldName = meta.getFieldNames()[fieldIndex];
    }

    public FielComparator getComparator() {
        return comparator;
    }

    public void put(Object key, LogicalOid logicalOid) {
        if (map.containsKey(key)) {
            ((Set) map.get(key)).add(logicalOid);
        } else {
            Set set = new HashSet();
            set.add(logicalOid);
            map.put(key, set);
        }
    }

    public void remove(Object key, LogicalOid logicalOid) {
        if (map.containsKey(key)) {
            Set oids = (Set) map.get(key);
            oids.remove(logicalOid);
            if (oids.isEmpty()) {
                map.remove(key);
            }
        } else {
            throw new QueryEngineException("can't find value " + key + " in index");
        }
    }

    public Set get(Object key) {
        return (Set) map.get(key);
    }

    public Set keySet() {
        return map.keySet();
    }

    public InFileAddress getIfa() {
        return ifa;
    }

    public void deleteIndex() {
        throw new RuntimeException("not implemented yet...");
    }

    public String toFullString() {
        return toString();
    }

    public String toString() {
        return "IndexHashMapImpl(" + className + "," + fieldName + ")";
    }

    public void setIndexManager(IndexManager indexManager) {
    }

    private InFileAddress ifa;
    private FielComparator comparator;
    private HashMap map;
    private String className;
    private String fieldName;

    public static final short TYPE = 1;
}
