/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query.operator;

import org.objectweb.jalisto.se.api.query.Operator;

public class OperatorFactory {

    public static Operator getEqualOperator() {
        return equalOperator;
    }

    public static Operator getSmallerOperator() {
        return smallerOperator;
    }

    public static Operator getGreaterOperator() {
        return greaterOperator;
    }

    public static Operator getStartsWithOperator() {
        return startsWithOperator;
    }

    public static Operator getEndsWithOperator() {
        return endsWithOperator;
    }

    public static Operator getContainsOperator() {
        return containsOperator;
    }

    public static Operator getIdentityOperator() {
        return identityOperator;
    }

    private static final EqualOperator equalOperator = new EqualOperator();
    private static final SmallerOperator smallerOperator = new SmallerOperator();
    private static final GreaterOperator greaterOperator = new GreaterOperator();
    private static final StartsWithOperator startsWithOperator = new StartsWithOperator();
    private static final EndsWithOperator endsWithOperator = new EndsWithOperator();
    private static final ContainsOperator containsOperator = new ContainsOperator();
    private static final IdentityOperator identityOperator = new IdentityOperator();
}
