/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query.parameter;

import org.objectweb.jalisto.se.api.MetaRepository;
import org.objectweb.jalisto.se.api.query.Query;
import org.objectweb.jalisto.se.query.QueryImpl;
import org.objectweb.jalisto.se.query.execution.ExecutionTree;

public class SubQuery {

    public SubQuery(Query subQuery) {
        this.query = (QueryImpl) subQuery;
    }

    public Query getQuery() {
        return query;
    }

    public ExecutionTree getTree(MetaRepository repository) {
        if (tree == null) {
            String subQueriedClass = query.getQueriedClassName();
            tree = new ExecutionTree(query.getBinaryTree(), repository, subQueriedClass);
        }
        return tree;
    }

    public void deleteTree() {
        this.tree = null;
    }


    private QueryImpl query;
    private ExecutionTree tree;
}
