/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query.result;

import org.objectweb.jalisto.se.impl.LogicalOid;
import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.impl.util.JalistoUtils;

public class QueryResultWrapper implements Comparable {

    public QueryResultWrapper(LogicalOid loid, Object[] value) {
        this.logicalOid = loid;
        this.value = value;
    }

    public QueryResultWrapper() {
    }

    public LogicalOid getLogicalOid() {
        return logicalOid;
    }

    public void setLogicalOid(LogicalOid logicalOid) {
        this.logicalOid = logicalOid;
    }

    public Object[] getValue() {
        return value;
    }

    public void setValue(Object[] value) {
        this.value = value;
    }

    public boolean isReaded() {
        return (value != null);
    }

    public int hashCode() {
        return logicalOid.hashCode();
    }

    public boolean equals(Object o) {
        try {
            return this.logicalOid.equals(((QueryResultWrapper) o).logicalOid);
        } catch (Exception e) {
        }
        return false;
    }

    public String toString() {
        return "(" + String.valueOf(logicalOid) + "," + JalistoUtils.arrayToString(value);
    }

    public String toStringFull(Session session) {
        return "(" + String.valueOf(logicalOid) + "," + JalistoUtils.arrayToString(value, session);
    }

    public int compareTo(Object object) {
        QueryResultWrapper candidate = (QueryResultWrapper) object;
        return this.logicalOid.compareTo(candidate.logicalOid);
    }

    private LogicalOid logicalOid;
    private Object[] value;
}
