/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.test.query;

import org.objectweb.jalisto.se.test.workbench.JalistoTestCase;
import org.objectweb.jalisto.se.api.ClassDescription;
import org.objectweb.jalisto.se.api.query.Index;
import org.objectweb.jalisto.se.query.exception.QueryEngineException;

public class JalistoQueryTestCase extends JalistoTestCase {

    public JalistoQueryTestCase() {
    }

    public JalistoQueryTestCase(String name) {
        super(name);
    }

    public void buildIndex(Class aClass, String fieldName) {
        if (indexManager != null) {
            ClassDescription meta = session.getMetaRepository().getMetaData(aClass.getName());
            int fieldIndex = meta.getIndex(fieldName);
            tx.begin();
            indexManager.buildIndexOnField(meta, fieldIndex);
            tx.commit();
        }
    }

    public void deleteIndex(Class aClass, String fieldName) {
        if (indexManager != null) {
            ClassDescription meta = session.getMetaRepository().getMetaData(aClass.getName());
            int fieldIndex = meta.getIndex(fieldName);
            tx.begin();
            indexManager.deleteIndexOnField(meta, fieldIndex);
            tx.commit();
        }
    }

    public void printIndex(Class aClass, String fieldName) {
        if (indexManager != null) {
            tx.begin();
            try {
                ClassDescription meta = session.getMetaRepository().getMetaData(aClass.getName());
                int fieldIndex = meta.getIndex(fieldName);
                Index index = indexManager.getIndex(meta, fieldIndex);
                System.out.println("index : " + index.toFullString());
            } catch (QueryEngineException jalistoQee) {
                System.out.println(jalistoQee.getMessage());
            }
            tx.commit();
        }
    }
}
